<template>
  <div class="content">
    <PageTitle>Accounts</PageTitle>
    <div class="col-12 drop-shadow border-radius p-4">
      <SearchField class="w-100 mb-4" v-model="searchQuery"></SearchField>
      <GridComponent
        :data="data"
        :columns="columns"
        :filterKey="searchQuery"
      ></GridComponent>
    </div>
  </div>
</template>

<script>
import PageTitle from "./atoms/PageTitle.vue";
import GridComponent from "./organisms/GridComponent.vue";
import SearchField from "./atoms/SearchField.vue";
import axios from "axios";
import store from "@/store/auth";

export default {
  components: { PageTitle, GridComponent, SearchField },
  data() {
    return {
      data: [],
      columns: ["rol", "naam", "stad"],
      searchQuery: "",
    };
  },
  created() {
    this.getAccount();
  },
  methods: {
    async getAccount() {
      store.commit("general/setLoading", true);
      try {
        await axios.get("/api/user/all").then((response) => {
          if (response.status === 200) {
            this.setAndRefactor(response.data);
          }
          store.commit("general/setLoading", false);
        });
      } catch (error) {
        console.log(error);
        store.commit("general/setLoading", false);
      }
    },
    setAndRefactor(accounts) {
      this.data = [];
      accounts.forEach((account) => {
        console.log(account);
        this.data.push({
          id: account.id ?? "Error",
          rol: account.role ?? "Error",
          naam: account.name ?? "Onbekend",
          route: account.route?.name ?? "Onbekend",
          stad: account.regions[0]?.name ?? "Onbekend",
          status: account.completedRoutes ?? 0,
        });
      });
    },
  },
};
</script>

<style lang="scss">
.content {
  display: flex;
  flex-direction: column;
}
</style>
